# ------------------------ Apache Version 2.0 license -------------------------
#    Copyright (C) 2001-2006 Rony G. Flatscher
#
#    Licensed under the Apache License, Version 2.0 (the "License");
#    you may not use this file except in compliance with the License.
#    You may obtain a copy of the License at
#
#        http://www.apache.org/licenses/LICENSE-2.0
#
#    Unless required by applicable law or agreed to in writing, software
#    distributed under the License is distributed on an "AS IS" BASIS,
#    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#    See the License for the specific language governing permissions and
#    limitations under the License.
# -----------------------------------------------------------------------------

# nmake /f os2_bsf4rexx.mak [all | clean | rebuild]
#
# This Makefile originates from John Small who has helped build the
# DLL for OS/2 Warp machines in May 2001; kudos to John Small !
#
# Created by IBM WorkFrame/2 MakeMake at 9:42:36 on 25 May 2001
#
# The actions included in this make file are:
#
# Now that Java is dynamically loaded no explicit linking with
# "javai.dll" or "jvm.dll" necessary anymore (---rgf, 2003-08-15)


# DEFS_RGF = /DUSE_OREXX
DEFS_RGF = /DIBMVACPP

# .SUFFIXES: .cc .obj

all : .\bsf4rexx-os2.map .\BSF4Rexx-os2.dll

# how to get from "cc" to "obj"
# .cc.obj :
.\BSF4Rexx-os2.obj : BSF4Rexx.cc
    @echo " Compile::C++ Compiler .cc.obj"
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF)/Sa /Q /Gm /Ge- /Ms /C %s

# folgendes funktioniert
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Ms /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc


# 2006-03-19, reading John Small's posting in <news:comp.os.os2.programmer.misc> "OT: Calling convetions in assembly code"... and
#             the given links in his answer to: <http://www.warpspeed.com.au/cgi-bin/inf2html.cmd?..%5Chtml%5Cbook%5CIBMVACPP%5CCPPPROG.INF+152>
#
# You can specify any of the calling conventions for all functions within a program using the /Mp (for _Optlink) or /Ms (for _System) compiler option.
# You can also use the /Mt option to specify __stdcall and the /Mc option to specify __cdecl.
#
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Mp /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Ms /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Mt /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc
#    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Mc /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc
    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge-     /C /FoBSF4Rexx-os2.obj BSF4Rexx.cc



.\bsf4rexx-os2.map .\BSF4Rexx-os2.dll : .\BSF4Rexx-os2.obj {$(LIB)}REXX.LIB {$(LIB)}BSF4RexxOS2.def
    @echo " Link::Linker "
    icc.exe @<<
     /Q /B"/noe /m "
     /FeBSF4Rexx-os2.dll
     /Fm"bsf4rexx-os2.map"
     REXX.LIB
     BSF4RexxOS2.def
     .\BSF4Rexx-os2.obj
<<

# copy .\BSF4Rexx-os2.dll .\BSF4Rexx.dll




.\BSF4Rexx-os2.obj: .\BSF4Rexx.cc {.\BSF4Rexx-os2;$(INCLUDE);}org_rexxla_bsf_engines_rexx_RexxAndJava.h

# .\BSF4Rexx-os2.obj: .\BSF4Rexx.cc {.\BSF4Rexx-os2;$(INCLUDE);}com_ibm_bsf_engines_rexx_RexxAndJava.h

# removes the intermediary files, causes "all" in turn to re-create the dll from scratch
clean :
   - del BSF4Rexx-os2.map
   - del BSF4Rexx-os2.obj


# first "clean", then cause "all" to create the dll from scratch
rebuild : clean all


# create an .i-file
i :
    icc.exe /O+ /Tdp -DOS2 $(DEFS_RGF) /Sa /Q /Gm /Ge- /Ms /C /P BSF4Rexx.cc




